public class ActionList {
    public int cause_list[][]; 
    /* cause_list[i][0] and cause_list[i][1] denote the ith cause msg/ack type and person/label required. */ 

    // public int reaction_type[][]; 
    /* reaction_type[j][0], reaction_type[j][1], and reaction_type[j][2] 
       denote the jth reaction. */

    public Letter reaction[];

    public boolean happenedYet;

    public ActionList() {
	happenedYet = false;
    }

    public void fillActionList(String cause, String effect, int pid) {
	this.fillCause(cause);
	this.fillEffect(effect, pid);
    }

    public void fillCause(String cause) {
	char c = cause.charAt(0);
	char d;
	String t, temp;
	int val, ind, loc;
	int i, k;

	if (c == 's') {
	    cause_list = new int[1][2];
	    cause_list[0][0] = 0;
	    cause_list[0][1] = 0;
	} else if (c == '(') {
	    d = cause.charAt(1);
	    temp = cause.substring(3, cause.length() - 1);
	    val = Integer.parseInt(temp);

	    cause_list = new int[1][2];
	    if (d == 'm') {
		cause_list[0][0] = 0;
	    } else if (d == 'a') {
		cause_list[0][0] = 1;
	    } else {
		cause_list[0][0] = -1;
	    }

	    cause_list[0][1] = val;
	} else if (c == 'o') {
	    t = cause.substring(2, cause.length() - 1);
	    k = Parser.countInstances(t, '(');
	    cause_list = new int[k][2];

	    loc = 1;
	    for (i = 0; i < cause_list.length; i++) {
		ind = t.indexOf(')', loc);
		d = t.charAt(loc);
		temp = t.substring(loc + 2, ind);
		val = Integer.parseInt(temp);

		if (d == 'm') {
		    cause_list[i][0] = Letter.MESSAGE;
		} else if (d == 'a') {
		    cause_list[i][0] = Letter.ACK;
		} else {
		    cause_list[i][0] = -1;
		}
		
		cause_list[i][1] = val;

		loc = ind + 3;
	    }
	}
    }

    public void fillEffect(String effect, int pid) {
	String t = effect.substring(1, effect.length() - 1);
	String temp;
	String ping;
	String contents[][];
	int k = Parser.countInstances(t, ')');
	int i;
	int loc = 1;
	int ebl;
	int loc1, loc2;
	int val1, val2;
	char c;

	// reaction_type = new int[k][3];
	reaction = new Letter[k];
	for (i = 0; i < reaction.length; i++) {

	    ebl = t.indexOf(']', loc);
	    ping = t.substring(loc + 1, ebl);
	    contents = createContents(ping);
	    // c = t.charAt(loc);

	    loc1 = t.indexOf(',', ebl + 2);
	    temp = t.substring(ebl + 2, loc1);
	    val1 = Integer.parseInt(temp);

	    loc2 = t.indexOf(')', loc1 + 1);
	    temp = t.substring(loc1 + 1, loc2);
	    val2 = Integer.parseInt(temp);

	    /*
	      if (c == 'm') {
	      reaction_type[i][0] = Letter.MESSAGE;
	      } else if (c == 'a') {
	      reaction_type[i][0] = Letter.ACK;
	      } else {
	      reaction_type[i][0] = -1;
	      }
	      
	      reaction_type[i][1] = val1;
	      reaction_type[i][2] = val2;
	    */

	    reaction[i] = new Letter(pid, val1, val2, contents);

	    loc = loc2 + 2;
	}
	
    }

    public String[][] createContents(String s) {
	// System.out.println("s_part = \""+s+"\"");
	String doov[] = Parser.split(s, "&&");
	String groov[][] = new String[doov.length][];
	String tape[][];
	int count = 0;
	int i,j, th;
	for (i = 0; i < doov.length; i++) {
	    groov[i] = Parser.split(doov[i], ",");
	    // count = count + groov.length;
	    count = count + (groov[i].length - 1);
	}
	tape = new String[count][2];
	
	th = 0;
	for (i = 0; i < groov.length; i++) {
	    for (j = 1; j < groov[i].length; j++) {
		tape[th][0] = 
		    groov[i][0];
		tape[th][1] = groov[i][j];
		th++;
	    }
	}
	return tape;
    }
}
